﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ButtonBehaviour : MonoBehaviour {

	public bool catFound = false;
	public int catSpeed = 0;
	int triggerButtonTimer = 0;
	AudioSource source;
	public TriggerObject[] reactiveObject;
	SpriteRenderer spriterend;
	public Sprite[] sprites;

	public GameManager manager;
	public Animator anim;
	// Use this for initialization
	void Start () {
		source = GetComponent<AudioSource> ();
		spriterend = GetComponent<SpriteRenderer> ();
	}
	
	// Update is called once per frame
	void FixedUpdate () {
		if (manager.gameStarted) {
			if (catFound) {
				triggerButtonTimer += catSpeed;
				if (triggerButtonTimer >= 1750) {
					//Katze Pfote hoch
					showPawUp ();
				}
				if (triggerButtonTimer >= 3500) {
					triggerButtonTimer = 0;
					foreach (TriggerObject trigger in reactiveObject) {
						source.Play ();
						//Katze Pfote runter
						showPawDown ();
						trigger.performAction ();
					}
				}
			}
		}
	}


	public void showPawUp(){
		if (catSpeed == 10) {
			spriterend.sprite = sprites[0];
		} else if (catSpeed == 20) {
			spriterend.sprite = sprites[1];
		} else if (catSpeed == 50) {
			spriterend.sprite = sprites[2];
		}
	}

	public void showPawDown(){
		if (catSpeed == 10) {
			spriterend.sprite = sprites[3];
		} else if (catSpeed == 20) {
			spriterend.sprite = sprites[4];
		} else if (catSpeed == 50) {
			spriterend.sprite = sprites[5];
		}
	}

	public void animate(){
		

		if (catSpeed == 10) {
			anim.SetBool ("isFast", false);
			anim.SetBool ("isNormal", false);
			anim.SetBool ("isSlow", true);
		} else if (catSpeed == 20) {
			anim.SetBool ("isFast", false);
			anim.SetBool ("isSlow", false);
			anim.SetBool ("isNormal", true);
		} else if (catSpeed == 50) {
			anim.SetBool ("isSlow", false);
			anim.SetBool ("isNormal", false);
			anim.SetBool ("isFast", true);
		}

	}
}
