﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class MapGenerator : MonoBehaviour {

	public Transform tilePrefab;
	public Transform obstaclePrefab;
	public Vector2 mapSize;

	[Range(0,1)]
	public float outlinePercent;

	[Range(0,1)]
	public float obstaclePercent;

	public bool obstacleAsBorder = true;

	public int seed = 10;

	void Start(){
		GenerateMap ();

	}


	public void GenerateMap(){

		//Refreshes the Editor Objects
		string holderName = "Generated Map";
		if (transform.FindChild (holderName)) {
			DestroyImmediate (transform.FindChild (holderName).gameObject);
		}


		Transform mapHolder = new GameObject (holderName).transform;
		mapHolder.parent = transform;

		//Loop for Tile Generation
		for (int x = 0; x < mapSize.x; x++) {
			for (int y = 0; y < mapSize.y; y++) {
				Vector3 tilePosition = new Vector3 (-mapSize.x / 2 + 0.5f + x, 0, -mapSize.y / 2 + 0.5f + y);
				Transform newTile = Instantiate (tilePrefab, tilePosition, Quaternion.Euler (Vector3.right * 90)) as Transform;
				newTile.localScale = Vector3.one * (1 - outlinePercent);
				newTile.parent = mapHolder;
			}
		}

		//Place Obstacles

		/*
		if (obstacleAsBorder == true) {
			for (int x = 0; x < mapSize.x; x++) {
				for (int y = 0; y < mapSize.y; y++) {
					if (x == 0 || x == mapSize.x - 1) {
						Debug.Log ("Place Obstacle at (" + x + "|" + y + ")");
						Vector3 obstaclePosition = new Vector3 (-mapSize.x / 2 + 0.5f + x, 0, -mapSize.y / 2 + 0.5f + y);
						Transform newObstacle = Instantiate (obstaclePrefab, obstaclePosition + Vector3.up * .5f, Quaternion.identity) as Transform;
						newObstacle.localScale = Vector3.one * (1 - outlinePercent);
						newObstacle.parent = mapHolder;
					} else {
						if (y == 0 || y == mapSize.y - 1) {
							Debug.Log ("Place Obstacle at (" + x + "|" + y + ")");
							Vector3 obstaclePosition = new Vector3 (-mapSize.x / 2 + 0.5f + x, 0, -mapSize.y / 2 + 0.5f + y);
							Transform newObstacle = Instantiate (obstaclePrefab, obstaclePosition + Vector3.up * .5f, Quaternion.identity) as Transform;
							newObstacle.localScale = Vector3.one * (1 - outlinePercent);
							newObstacle.parent = mapHolder;
						}
					}
				}
			}
		}
		*/
	}
}
